// Kim.java                                         MM 2013
import Tools.IO.*;                              // Eingaben

/**
 * Kimspiel, Gedaechtnistraining,
 * Spiel fuer eine Person.
 * Eine Zahl mit 2 ... 10 Stellen wird angezeigt,
 * ausgeblendet und danach eingegeben.
 * Ist die Eingabe unkorrekt,
 * so wird das Spiel beendet.
 * @author Monika Meiler
 */
public class Kim
{
/* ----------------------------------------------------- */
                                               // Attribute
/**
 * Anzahl der Stellen der Merkzahl.
 */
  private int stellen;

/* ----------------------------------------------------- */
                                             // Spielaufbau
/**
 * Spiel starten.
 */
  public void starten()
  {
    // Erlaeuterung
    System.out.println();
    erlaeuterung();

    System.out.println();
    IOTools.readLine( "Weiter (ENTER) ");

    // Spielstart
    char weiter = 'j';
    do
    {
      // Spiel
      System.out.println();
      spielen();

      // Auswertung
      System.out.println();
      auswertung();

      // Weiter
      weiter = IOTools.readChar( "Noch einmal (j/n)? ");
    } while( weiter == 'j');

    // Beenden
    System.out.println();
    System.out.println( "Spiel beendet!");
  }

/* ----------------------------------------------------- */
                                                   // Spiel
/**
 * Spielerlaeuterung.
 */
  private void erlaeuterung()
  {
    String str = "Kimspiel, Gedaechtnistraining, ";
    str += "Spiel fuer eine Person.\n\n";

    str += "Eine Zahl mit 2 ... 10 Stellen wird angezeigt,\n";
    str += "ausgeblendet und danach eingegeben.\n";
    str += "Ist die Eingabe unkorrekt, ";
    str += "so wird das Spiel beendet.";

    System.out.println( str);
  }

/**
 * Stellenzahl festlegen, Wuerfeln,
 * Anzeigen, Ausblenden, Eingeben, Vergleichen.
 */
  public void spielen()
  {
    // Anfangsdaten
    stellen = 1;
    int max = 10, min = 1;

    // Spielrunden
    int merkZahl, rateZahl;
    do
    {
      // Stellenzahl erhoehen
      stellen++;
      min *= 10;
      max *= 10;

      // Wuerfel
      Wuerfel wuerfel = new Wuerfel();
      wuerfel.setWuerfel( min, max - 1);
      merkZahl = wuerfel.wuerfeln();

      for( int i = 0; i < 80; i++)              // Loeschen
        System.out.println();

      System.out.println();                       // Zeigen
      System.out.print( "Merke Dir:                 ");
      System.out.println( ">> " + merkZahl + " <<");

      IOTools.readLine( "Weiter (ENTER) ");       // Weiter

      for( int i = 0; i < 80; i++)              // Loeschen
        System.out.println();

      rateZahl = IOTools.readInteger            // Eingaben
                 ( "Wie lautet die Zahl ?         ");

    } while( merkZahl == rateZahl);
  }

/**
 * Spielauswertung.
 */
  private void auswertung()
  {
    String str = "";
    stellen--;
    if( stellen > 1)
    {
      str += "Du hast Dir Zahlen mit ";
      str += stellen + " Stellen gemerkt.\n";
    }

    if( stellen > 7) str += "Spitze!";
    else if( stellen > 5) str += "Gut!";
    else if( stellen > 3) str += "Es wird schon!";

    if( stellen <= 3) str += "Training tut gut!";

    System.out.println( str);
 }

/* ----------------------------------------------------- */
                                                // Programm
/**
 * Startet ein Kimpiel.
 */
  public static void main( String[] args)
  {
// Kimspiel erzeugen
    Kim kim = new Kim();

// Kimspiel starten
    kim.starten();
  }
}
