// LottoFee.java                                    MM 2013
import Tools.IO.*;                              // Eingaben

/**
 * Lottoziehung 6 aus 49,
 * Ziehungsautomat gibt beliebig viele Lottotipps aus.
 * @author Monika Meiler
 */
public class LottoFee
{
/* ----------------------------------------------------- */
                                               // Attribute
/**
 * Wuerfel.
 */
  private Wuerfel wuerfel = new Wuerfel();

/**
 * Lottozahlen.
 */
  private int[] zahlen = new int[ 6];

/* ----------------------------------------------------- */
                                             // Spielaufbau
/**
 * Spiel starten.
 */
  public void starten()
  {
// Erlaeuterung
    System.out.println();
    erlaeuterung();

    System.out.println();
    IOTools.readLine( "Weiter (ENTER) ");

// Spielstart
    char weiter = 'j';
    do
    {
      System.out.println();                        // Spiel
      spielen();

      System.out.println();                   // Auswertung
      auswertung();
                                                  // Weiter
      weiter = IOTools.readChar( "Noch einmal (j/n)? ");
    } while( weiter == 'j');

// Beenden
    System.out.println();
    System.out.println( "Spiel beendet!");
  }

/* ----------------------------------------------------- */
                                                   // Spiel
/**
 * Spielerlaeuterung.
 */
  private void erlaeuterung()
  {
    String str = "Lottoziehung 6 aus 49.\n\n";
    str += "Gibt beliebig viele Lottotipps aus.";

    System.out.println( str);
  }

/**
 * Ziehen und Ordnen der Zahlen.
 */
  private void spielen()
  {
      ziehen();                        // Ziehen der Zahlen
      ordnen();                        // Ordnen der Zahlen
  }

/**
 * Zahlen werden gezogen.
 */
  private void ziehen()
  {
    wuerfel.setWuerfel( 1, 49);
    boolean doppelt;
    for( int i = 0; i < zahlen.length; i++)
    do
    {
      doppelt = false;                 // Ziehen einer Zahl
      zahlen[ i] = wuerfel.wuerfeln();

              // Vergleich mit den bereits gezogenen Zahlen
      for( int j = 0; j < i; j++)
        if( zahlen[ j] == zahlen[i]) doppelt = true;
    } while( doppelt);
  }

/**
 * Zahlen werden geordnet.
 */
  private void ordnen()
  {                                           // SelectSort
    for( int i = 0; i < zahlen.length - 1; i++)
    {
      int k = i;
      for( int j = i + 1; j < zahlen.length; j++)
        if( zahlen[ k] > zahlen[ j]) k = j;
      if( i != k)
      {
        int temp = zahlen[ i];               // Vertauschen
        zahlen[ i] = zahlen[ k];
        zahlen[ k] = temp;
      }
    }
  }

/**
 * Ziehungsergebnis.
 */
  public void auswertung()
  {
    String str = "";
    for( int i = 0; i < zahlen.length; i++)
      str += " " + zahlen[ i];
    System.out.println( str);
  }

/* ----------------------------------------------------- */
                                                // Programm
/**
 * Programm,
 * erzeugt und startet einen Ziehungsautomaten.
 */
  public static void main( String[] args)
  {
// Ziehungsautomat erzeugen
    LottoFee tipp = new LottoFee();

// Ziehungsautomat starten
    tipp.starten();
  }
}
