// TicTacToe.java                                   MM 2013
import Tools.IO.*;                              // Eingaben

/**
 * TicTacToe - Spiel fuer zwei Personen.
 * Zwei Spieler setzen abwechselnd Steine auf ein
 * 3x3 - Spielbrett. Gewonnen hat der Spieler, der
 * mit seinen Steinen zuerst eine Zeile, eine Spalte
 * oder eine Diagonale besetzt hat.
 * @author Monika Meiler
 */
public class TicTacToe
{
/* ----------------------------------------------------- */
                                               // Attribute
/**
 * Spielbrettbreite.
 */
  private final int laenge = 3;

/**
 * Spielbrett.
 */
  private char[][] brett;

/**
 * Zwei Spieler.
 */
  private char[] spieler = { 'x', 'o'};

/**
 * Aktueller Spieler.
 */
  private int dran = 0;

/**
 * Spielrundenzaehler.
 */
  private int runde = 0;

/* ----------------------------------------------------- */
                                             // Spielaufbau
/**
 * Spiel starten.
 */
  public void starten()
  {
// Erlaeuterung
    System.out.println();
    erlaeuterung();

    System.out.println();
    IOTools.readLine( "Weiter (ENTER) ");

// Spielstart
    char weiter = 'j';
    do
    {
      System.out.println();                        // Spiel
      spielen();

      System.out.println();                   // Auswertung
      auswertung();

                                                  // Weiter
      weiter = IOTools.readChar( "Noch einmal (j/n)? ");
    } while( weiter == 'j');

// Beenden
    System.out.println();
    System.out.println( "Spiel beendet!");
  }

/* ----------------------------------------------------- */
                                                   // Spiel
/**
 * Spielerlaeuterung.
 */
  private void erlaeuterung()
  {
    String str = "TicTacToe, ";
    str += "Spiel fuer zwei Personen.\n";
    str += "Zwei Spieler setzen abwechselnd Steine ";
    str += "auf ein 3x3 - Spielbrett.\n";
    str += "Gewonnen hat der Spieler, ";
    str += "der mit seinen Steinen zuerst\n";
    str += "eine Zeile, eine Spalte oder ";
    str += "eine Diagonale besetzt hat.";

    System.out.println( str);
  }

/**
 * Eingabe der Steinanzahl und der Spieler, Spielen.
 */
  private void spielen()
  {
// leeres Spielbrett
    leereBrett();

// Spielstart
    runde = 0;                             // Rundenzaehler

// Spielrunden
    boolean sieger = false;
    boolean patt = true;
    do
    {
      runde++;

      System.out.println();            // naechster Spieler
      ziehen();
      System.out.println();

      System.out.println();            // Spielbrett zeigen
      zeigeBrett();
      System.out.println();
                                                  // Fertig
      sieger = gewonnen();
      patt = runde == laenge * laenge;
    } while( !patt && !sieger);

    if( sieger)                                   // Sieger
      System.out.println
      ( "Sieger: Spieler " + spieler[ dran]);
    else
      System.out.println( "Patt!");
  }

/**
 * Spielauswertung.
 */
  private void auswertung()
  {
    String str = "Runde: " + runde + ", ";
    str += "geuebte Spieler spielen Patt!";
    System.out.println( str);
  }

/* ----------------------------------------------------- */

/**
 * Spielbrett wird geleert.
 */
  private void leereBrett()
  {
    brett = new char[ laenge][ laenge];
    for( int z = 0; z < brett.length; z++)
      for( int s = 0; s < brett[ 0].length; s++)
        brett[ z][ s] = ' ';
  }

/* ----------------------------------------------------- */

/**
 * Spielbrett wird gezeigt.
 */
  private void zeigeBrett()
  {
    for( int z = 0; z < brett.length; z++)
    {
      System.out.print( " | ");
      for( int s = 0; s < brett[ 0].length; s++)
        System.out.print( brett[ z][ s] + " | ");
      System.out.println();
    }
  }

/* ----------------------------------------------------- */

/**
 * Spielbretttest auf Gewinnpositionen.
 * @return true, falls Gewinnposition, sonst false
 */
  private boolean gewonnen()
  {
                                              // Zeilentest
    for( int z = 0; z < brett.length; z++)
      if( brett[ z][ 0] != ' ' &&
          brett[ z][ 0] == brett[ z][ 1] &&
          brett[ z][ 0] == brett[ z][ 2]) return true;

                                             // Spaltentest
    for( int s = 0; s < brett[ 0].length; s++)
      if( brett[ 0][ s] != ' ' &&
          brett[ 0][ s] == brett[ 1][ s] &&
          brett[ 0][ s] == brett[ 2][ s]) return true;

                                // positiver Diagonalentest
    if( brett[ 0][ 0] != ' ' &&
        brett[ 0][ 0] == brett[ 1][ 1] &&
        brett[ 0][ 0] == brett[ 2][ 2]) return true;

                                // negativer Diagonalentest
    if( brett[ 0][ 2] != ' ' &&
        brett[ 0][ 2] == brett[ 1][ 1] &&
        brett[ 0][ 2] == brett[ 2][ 0]) return true;

    return false;
  }

/* ----------------------------------------------------- */

/**
 * Naechster Spieler setzt seinen Stein.
 */
  private void ziehen()
  {
    dran = 1 - dran;                   // naechster Spieler

    System.out.println
    ( "Spieler " + spieler[ dran] + " ist dran!");
    System.out.println();

    int z, s;                               // Stein setzen
    do
    {
      do
      {
        z = 
        IOTools.readInteger( "Zeile  (0<=z<=2), z = ");
      } while( z < 0 || z > 2);
      do
      {
        s =
        IOTools.readInteger( "Spalte (0<=s<=2), s = ");
      } while( s < 0 || s > 2);
    } while( brett[ z][ s] != ' ');              // besetzt

      brett[ z][ s] = spieler[ dran];
  }

/* ----------------------------------------------------- */
                                                // Programm
/**
 * Programm, erzeugt und startet das TicTacToe.
 */
  public static void main( String[] args)
  {
// Spiel erzeugen
    TicTacToe ttt = new TicTacToe();

// Spiel starten
    ttt.starten();
  }
}
