// BanditTest.java                                  MM 2013
// Numerische Fehler
// (Datenfehler, Rechenfehler, Verfahrensfehler)
import Tools.IO.*;                               // Eingabe

/**
 * Der einarmige Bandit,
 * experimentelle Ermittlung der relativen
 * Haeufigkeiten der Gewinne.
 * @author Monika Meiler
 */
public class BanditTest
{
/**
 * Programm wuerfelt mehrmals mit drei Wuerfel 0..9,
 * erstellt eine bersicht der Gewinne
 * und berechnet deren relativen Haeufigkeiten.
 */
  public static void main( String[] args)
  {
// Ueberschrift
    System.out.println( "Der einarmige Bandit - Test");

// Wuerfel
    Wuerfel wuerfel = new Wuerfel();
    wuerfel.setWuerfel( 0, 9);

// Absoluten Haeufigkeit der Gewinne
    long einfach = 0;
    long doppelt = 0;
    long dreifach = 0;

// Anzahl Runden
    int anzahlRunden
    = IOTools.readInteger( "Wie oft wuerfeln? ");

// Wuerfeln
    System.out.println
    ( "ACHTUNG: Die Berechnung dauert u. U. etwas laenger!");
    for( int runde = 0; runde < anzahlRunden; runde++)
    {
      int zahl1 = wuerfel.wuerfeln();                // Zug
      int zahl2 = wuerfel.wuerfeln();
      int zahl3 = wuerfel.wuerfeln();
/*
      System.out.println
      ( zahl1 + " " + zahl2 + " " + zahl3);
*/

      int f = 1;                        // Gewinnberechnung
      if( zahl1 == zahl2) f++;
      if( zahl1 == zahl3) f++;
      if( zahl2 == zahl3) f++;

      if( f == 1) einfach++;
      if( f == 2) doppelt++;
      if( f == 4) dreifach++;
    }

// Ausgabe der relativen Haeufigkeiten
    System.out.println( "Relative Haeufigkeiten");

    System.out.println();
    System.out.print(" einfach : ");
    System.out.println((double)einfach / anzahlRunden);

    System.out.print(" doppelt : ");
    System.out.println((double)doppelt / anzahlRunden);

    System.out.print(" dreifach: ");
    System.out.println((double)dreifach / anzahlRunden);

// Fertig
    System.out.println();
    System.out.println( "Programm beendet");
  }
}

/* ----------------------------------------------------- */
/*
   Wahrscheinlichkeit ... einarmige Bandit:
    doppelt :  10 * (9+9+9) / 1000 = 0.27
    dreifach:  10 / 1000 = 0.01
    einfach :  1 - 0.27 - 0.01 = 0.72

   Der einarmige Bandit - Test, 1 Mrd Runden:
   Relative Haeufigkeiten
    einfach : 0.720003394
    doppelt : 0.269992887
    dreifach: 0.010003719
*/