// WuerfelFehler.java                               MM 2013
// Numerische Fehler
// (Datenfehler, Rechenfehler, Verfahrensfehler)
import Tools.IO.*;                               // Eingabe

/**
 * Wuerfel 1..6,
 * experimentelle Ermittlung der relativen Haeufigkeiten
 * der gewuerfelten Augenzahlen.
 * @author Monika Meiler
 */
public class WuerfelFehler
{
/**
 * Programm wuerfelt mehrmals mit dem Standardwuerfel,
 * erstellt eine Tabelle der absoluten Haeufigkeit
 * und berechnet die relativen Haeufigkeiten 
 * der gewuerfelten Augenzahlen.
 */
  public static void main( String[] args)
  {
// Ueberschrift
    System.out.println( "Wuerfel 1..6");

// Wuerfel
    Wuerfel wuerfelBlau = new Wuerfel();

// Tabelle der absoluten Haeufigkeiten
    int[] tabelle = new int[ 6];

// Anzahl Runden
    int anzahlRunden
    = IOTools.readInteger( "Wie oft wuerfeln? ");

// Wuerfeln
    System.out.println
    ( "ACHTUNG: Die Berechnung dauert u. U. etwas laenger!");
    for( int runde = 0; runde < anzahlRunden; runde++)
      tabelle[ wuerfelBlau.wuerfeln() - 1]++;

// Ausgabe der relativen Haeufigkeiten
    System.out.println
    ( "Tabelle der relative Haeufigkeiten");
    System.out.println();
    for( int i = 0; i < 6; i++)
    {
      System.out.print(( i + 1) + ": ");
      System.out.println
      ((double)tabelle[ i] / anzahlRunden);
    }

// Fertig
    System.out.println();
    System.out.println( "Programm beendet");
  }
}

/* ----------------------------------------------------- */
/*
   Wahrscheinlichkeit ... beim idealen Wuerfel:
   1 / 6 = 0.166666667

   Wuerfel 1..6, 1Mrd x wuerfeln:
   Tabelle der relative Haeufigkeiten

   1: 0.166672351
   2: 0.166646559
   3: 0.16667291
   4: 0.166682366
   5: 0.166672209
   6: 0.166653605
*/
